#ifndef _XBASCOUNTPRIV_H
#define _XBASCOUNTPRIV_H
#include "Xbascount.h"

/* private informations only used by basicop routines */

typedef struct XBC_Line XBC_Line ;

#define	MAX_HASH_SAT	256

/* enum list of basicop */
typedef enum XB_typ_obs {
		XBT_unknown = 0 ,
		XBT_add ,
		XBT_sub ,
		XBT_abs_s ,
		XBT_shl ,
		XBT_shr ,
		XBT_extract_h ,
		XBT_extract_l ,
		XBT_mult ,
		XBT_L_mult ,
		XBT_L_mult_X ,
		XBT_negate ,
		XBT_round ,
		XBT_L_mac ,
		XBT_L_mac_X ,
		XBT_L_msu ,
		XBT_L_msu_X ,
		XBT_L_macNs ,
		XBT_L_msuNs ,

	/* ponderation 2 */
		XBT_L_add ,
		XBT_L_sub ,
		XBT_L_add_c ,
		XBT_L_sub_c ,
		XBT_L_negate ,
		XBT_L_shl ,
		XBT_L_shr ,
		XBT_mult_r ,
		XBT_shr_r ,
		XBT_mac_r ,
		XBT_msu_r ,
		XBT_L_deposit_h ,
		XBT_L_deposit_l ,

	/* ponderation 3 */
		XBT_L_shr_r ,
		XBT_L_abs ,

	/* ponderation 4 */
		XBT_L_sat ,
	/* ponderation 15 */
		XBT_norm_s ,
	/* ponderation 18 */
		XBT_div_s  ,
	/* ponderation 30 */
		XBT_norm_l ,
	/* ponderation 1 */	
		XBT_DataMove16  ,
		XBT_DataMove32  ,
		XBT_Logic16  ,
		XBT_Logic32  ,
		XBT_and,
		XBT_or,
		XBT_xor,
	/* ponderation 2 */	
		XBT_L_and,
		XBT_L_or,
		XBT_L_xor,


		XBT_Test  ,
		XBT_MAX
}  XB_typ_obs ;


/* counters structure */
struct Xbas_count {
	char *name ;					/* name (identifier) of the structure */
	X_INT32	cntMin ;				/* min cycle count for the different frames */
	X_INT32	cntMax ;				/* max cycle count for the different frames */
	X_INT32 nbFrames ;				/* frame counter							*/
	X_INT32	cntInst[XBT_MAX] ;		/* basicop counters for the current frame	*/
	X_INT32 cntSat ;				/* saturation counter for the current frame	*/
	XBC_Line * headSat[MAX_HASH_SAT] ;	/* array of list heads for saturation counters	*/
	X_INT32	mode ;					/* control saturation counting				*/
	X_INT32	cntInstTot[XBT_MAX] ;	/* cumulative (between frames) basicop counters		*/
	X_INT32 cntSatTot ;				/* cumulative saturation counter			*/
	XBC_Line * headCount[MAX_HASH_SAT] ;	/* array of list heads for detailed line counter	*/
	X_INT32	nbLines ;
}  ;

/* some macro definitions for interaction between Xbascount and Xbasicops */
#if defined(XB_DEBUG)
extern Xbas_count *curCount ;
void XBC_Inc_Sat(Xbas_count * xbc,const char *ficName, X_INT32 line) ;
void XBC_Inc_Count(Xbas_count * xbc,XB_typ_obs instruct,const char *ficName, X_INT32 line) ;
void XBC_Dec_Count(Xbas_count * xbc,XB_typ_obs instruct,const char *ficName, X_INT32 line) ;
#define XBC_IncSat			XBC_Inc_Sat(curCount,file,line) 
//#define XBC_Incr(instruct)  curCount->cntInst[instruct]++ 
//#define XBC_Decr(instruct)  curCount->cntInst[instruct]-- 
#define XBC_Incr(instruct)  XBC_Inc_Count(curCount,instruct,file,line) 
#define XBC_Decr(instruct)  XBC_Dec_Count(curCount,instruct,file,line)  
#else
#define XBC_Incr(instruct)   
#define XBC_Decr(instruct) 
#define XBC_IncSat 
#endif

#endif












