#ifndef _XBASICOPS_H
#define _XBASICOPS_H
#include "x_default.h"

#if defined(WMOPS) && !defined(XB_DEBUG)
#	define	XB_DEBUG
#endif
#if defined(XB_INLINE)
#	define XB_INL	static _inline
#else
#	define XB_INL
#endif

#if !defined(XB_DEBUG)
#	define XB_DBG
#	define XB_DBG_VOID
#	define XB_DBG_ARG
#	define XB_DBG_ARG_VOID	void
#else
#	include	"Xbascount.h"
#	define XB_DBG	,xbc_file,__LINE__
#	define XB_DBG_VOID	xbc_file,__LINE__
#	define XB_DBG_ARG	,const char *file,int line
#	define XB_DBG_ARG_VOID	const char *file,int line
#endif


/* encapsulation to choose between debug and nodebug version */
#define XB_add(a16,b16)			xb_add((a16),(b16) XB_DBG)	
#define XB_sub(a16,b16)			xb_sub((a16),(b16) XB_DBG)	
#define XB_abs_s(a16)			xb_abs_s((a16) XB_DBG)	
#define XB_shl(a16,b16)			xb_shl((a16),(b16) XB_DBG)	
#define XB_shr(a16,b16)			xb_shr((a16),(b16) XB_DBG)	
#define XB_mult(a16,b16)		xb_mult((a16),(b16) XB_DBG)	
#define XB_L_mult(a16,b16)		xb_L_mult((a16),(b16) XB_DBG)	
#define XB_L_mult_X(a16,b16)	xb_L_mult_X((a16),(b16) XB_DBG)	
#define XB_negate(a16)			xb_negate((a16) XB_DBG)	
#define XB_extract_h(a32)		xb_extract_h((a32) XB_DBG)	
#define XB_extract_l(a32)		xb_extract_l((a32) XB_DBG)	
#define XB_round(a32)			xb_round((a32) XB_DBG)	
#define XB_L_mac(c32,a16,b16)	xb_L_mac((c32),(a16),(b16) XB_DBG)	
#define XB_L_mac_X(c32,a16,b16)	xb_L_mac_X((c32),(a16),(b16) XB_DBG)	

#define XB_L_msu(c32,a16,b16)	xb_L_msu((c32),(a16),(b16) XB_DBG)	
#define XB_L_msu_X(c32,a16,b16)	xb_L_msu_X((c32),(a16),(b16) XB_DBG)	
#define XB_L_macNs(c32,a16,b16)	xb_L_macNs((c32),(a16),(b16) XB_DBG)	
#define XB_L_msuNs(c32,a16,b16)	xb_L_msuNs((c32),(a16),(b16) XB_DBG)	
#define XB_L_add(a32,b32)		xb_L_add((a32),(b32) XB_DBG)	
#define XB_L_sub(a32,b32)		xb_L_sub((a32),(b32) XB_DBG)	
#define XB_L_add_c(a32,b32)		xb_L_add_c((a32),(b32) XB_DBG)	
#define XB_L_sub_c(a32,b32)		xb_L_sub_c((a32),(b32) XB_DBG)	
#define XB_L_negate(a32)		xb_L_negate((a32) XB_DBG)	
#define XB_mult_r(a16,b16)		xb_mult_r((a16),(b16) XB_DBG)	
#define XB_L_shl(a32,b16)		xb_L_shl((a32),(b16) XB_DBG)	
#define XB_L_shr(a32,b16)		xb_L_shr((a32),(b16) XB_DBG)	
#define XB_shr_r(a16,b16)		xb_shr_r((a16),(b16) XB_DBG)	
#define XB_mac_r(c32,a16,b16)	xb_mac_r((c32),(a16),(b16) XB_DBG)	
#define XB_msu_r(c32,a16,b16)	xb_msu_r((c32),(a16),(b16) XB_DBG)	
#define XB_L_deposit_h(a16)		xb_L_deposit_h((a16) XB_DBG)	
#define XB_L_deposit_l(a16)		xb_L_deposit_l((a16) XB_DBG)	
#define XB_L_shr_r(a32,b16)		xb_L_shr_r((a32),(b16) XB_DBG)	
#define XB_L_abs(a32)			xb_L_abs((a32) XB_DBG)	
#define XB_L_sat(a32)			xb_L_sat((a32) XB_DBG)	
#define XB_norm_s(a16)			xb_norm_s((a16) XB_DBG)	
#define XB_div_s(a16,b16)		xb_div_s((a16),(b16) XB_DBG)	
#define XB_norm_l(a32)			xb_norm_l((a32) XB_DBG)	
#define XB_Move16()				xb_Move16( XB_DBG_VOID)   
#define XB_Move32()				xb_Move32( XB_DBG_VOID)   
#define XB_Logic16()			xb_Logic16( XB_DBG_VOID)   
#define XB_Logic32()			xb_Logic32( XB_DBG_VOID)   
#define XB_and(a16,b16)			xb_and((a16),(b16) XB_DBG) 
#define XB_or(a16,b16)			xb_or((a16),(b16) XB_DBG) 
#define XB_xor(a16,b16)			xb_xor((a16),(b16) XB_DBG) 
#define XB_L_and(a32,b32)		xb_L_and((a32),(b32) XB_DBG) 
#define XB_L_or(a32,b32)		xb_L_or((a32),(b32) XB_DBG) 
#define XB_L_xor(a32,b32)		xb_L_xor((a32),b32) XB_DBG) 

#define XB_Test()				xb_Test( XB_DBG_VOID)   


#define XB_set_carry(a16)		xb_set_carry((a16)) 
#define XB_get_carry()			xb_get_carry() 
#define XB_set_overflow(a16)	xb_set_overflow((a16)) 
#define XB_get_overflow()		xb_get_overflow() 


/* encapsulation to be compatible with ETSI basicops */
/* encapsulation to choose between debug and nodebug version */
#define add(a16,b16)			xb_add((a16),(b16) XB_DBG)	
#define sub(a16,b16)			xb_sub((a16),(b16) XB_DBG)	
#define abs_s(a16)			xb_abs_s((a16) XB_DBG)	
#define shl(a16,b16)			xb_shl((a16),(b16) XB_DBG)	
#define shr(a16,b16)			xb_shr((a16),(b16) XB_DBG)	
#define mult(a16,b16)		xb_mult((a16),(b16) XB_DBG)	
#define L_mult(a16,b16)		xb_L_mult((a16),(b16) XB_DBG)	
#define L_mult_X(a16,b16)	xb_L_mult_X((a16),(b16) XB_DBG)	
#define negate(a16)			xb_negate((a16) XB_DBG)	
#define extract_h(a32)		xb_extract_h((a32) XB_DBG)	
#define extract_l(a32)		xb_extract_l((a32) XB_DBG)	
#define round(a32)			xb_round((a32) XB_DBG)	
#define L_mac(c32,a16,b16)	xb_L_mac((c32),(a16),(b16) XB_DBG)	
#define L_mac_X(c32,a16,b16)	xb_L_mac_X((c32),(a16),(b16) XB_DBG)	

#define L_msu(c32,a16,b16)	xb_L_msu((c32),(a16),(b16) XB_DBG)	
#define L_msu_X(c32,a16,b16)	xb_L_msu_X((c32),(a16),(b16) XB_DBG)	
#define L_macNs(c32,a16,b16)	xb_L_macNs((c32),(a16),(b16) XB_DBG)	
#define L_msuNs(c32,a16,b16)	xb_L_msuNs((c32),(a16),(b16) XB_DBG)	
#define L_add(a32,b32)		xb_L_add((a32),(b32) XB_DBG)	
#define L_sub(a32,b32)		xb_L_sub((a32),(b32) XB_DBG)	
#define L_add_c(a32,b32)		xb_L_add_c((a32),(b32) XB_DBG)	
#define L_sub_c(a32,b32)		xb_L_sub_c((a32),(b32) XB_DBG)	
#define L_negate(a32)		xb_L_negate((a32) XB_DBG)	
#define mult_r(a16,b16)		xb_mult_r((a16),(b16) XB_DBG)	
#define L_shl(a32,b16)		xb_L_shl((a32),(b16) XB_DBG)	
#define L_shr(a32,b16)		xb_L_shr((a32),(b16) XB_DBG)	
#define shr_r(a16,b16)		xb_shr_r((a16),(b16) XB_DBG)	
#define mac_r(c32,a16,b16)	xb_mac_r((c32),(a16),(b16) XB_DBG)	
#define msu_r(c32,a16,b16)	xb_msu_r((c32),(a16),(b16) XB_DBG)	
#define L_deposit_h(a16)		xb_L_deposit_h((a16) XB_DBG)	
#define L_deposit_l(a16)		xb_L_deposit_l((a16) XB_DBG)	
#define L_shr_r(a32,b16)		xb_L_shr_r((a32),(b16) XB_DBG)	
#define L_abs(a32)			xb_L_abs((a32) XB_DBG)	
#define L_sat(a32)			xb_L_sat((a32) XB_DBG)	
#define norm_s(a16)			xb_norm_s((a16) XB_DBG)	
#define div_s(a16,b16)		xb_div_s((a16),(b16) XB_DBG)	
#define norm_l(a32)			xb_norm_l((a32) XB_DBG)	
#define move16()				xb_Move16( XB_DBG_VOID)   
#define move32()				xb_Move32( XB_DBG_VOID)   
#define logic16()			xb_Logic16( XB_DBG_VOID)   
#define logic32()			xb_Logic32( XB_DBG_VOID)   
#define and(a16,b16)			xb_and((a16),(b16) XB_DBG) 
#define or(a16,b16)			xb_or((a16),(b16) XB_DBG) 
#define xor(a16,b16)			xb_xor((a16),(b16) XB_DBG) 
#define L_and(a32,b32)		xb_L_and((a32),(b32) XB_DBG) 
#define L_or(a32,b32)		xb_L_or((a32),(b32) XB_DBG) 
#define L_xor(a32,b32)		xb_L_xor((a32),b32) XB_DBG) 

#define test()				xb_Test( XB_DBG_VOID)   


#define set_carry(a16)		xb_set_carry((a16)) 
#define get_carry()			xb_get_carry() 
#define set_overflow(a16)	xb_set_overflow((a16)) 
#define get_overflow()		xb_get_overflow() 



 
/* function prototypes */                                                                                                                                                                                                                                                                                                                                                                                                     
XB_INL X_INT16 xb_add (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT16 xb_sub (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT16 xb_abs_s (X_INT16 var1 XB_DBG_ARG );
XB_INL X_INT16 xb_shl (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT16 xb_shr (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT16 xb_mult (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_mult (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_mult_X (X_INT16 var1, X_INT16 var2 XB_DBG_ARG) ;
XB_INL X_INT16 xb_negate (X_INT16 var1 XB_DBG_ARG);
XB_INL X_INT16 xb_extract_h (X_INT32 L_var1 XB_DBG_ARG);
XB_INL X_INT16 xb_extract_l (X_INT32 L_var1 XB_DBG_ARG);
XB_INL X_INT16 xb_round (X_INT32 L_var1 XB_DBG_ARG);
XB_INL X_INT32 xb_L_mac (X_INT32 L_var3, X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_mac_X (X_INT32 L_var3, X_INT16 var1, X_INT16 var2 XB_DBG_ARG) ;

XB_INL X_INT32 xb_L_msu (X_INT32 L_var3, X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_msu_X (X_INT32 L_var3, X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_macNs (X_INT32 L_var3, X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_msuNs (X_INT32 L_var3, X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_add (X_INT32 L_var1, X_INT32 L_var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_sub (X_INT32 L_var1, X_INT32 L_var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_add_c (X_INT32 L_var1, X_INT32 L_var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_sub_c (X_INT32 L_var1, X_INT32 L_var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_negate (X_INT32 L_var1 XB_DBG_ARG);
XB_INL X_INT16 xb_mult_r (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_shl (X_INT32 L_var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_shr (X_INT32 L_var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT16 xb_shr_r (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT16 xb_mac_r (X_INT32 L_var3, X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT16 xb_msu_r (X_INT32 L_var3, X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_deposit_h (X_INT16 var1 XB_DBG_ARG);
XB_INL X_INT32 xb_L_deposit_l (X_INT16 var1 XB_DBG_ARG);
XB_INL X_INT32 xb_L_shr_r (X_INT32 L_var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT32 xb_L_abs (X_INT32 L_var1 XB_DBG_ARG);
XB_INL X_INT32 xb_L_sat (X_INT32 L_var1 XB_DBG_ARG);
XB_INL X_INT16 xb_norm_s (X_INT16 var1 XB_DBG_ARG);
XB_INL X_INT16 xb_div_s (X_INT16 var1, X_INT16 var2 XB_DBG_ARG);
XB_INL X_INT16 xb_norm_l (X_INT32 L_var1 XB_DBG_ARG);

XB_INL void	xb_Move16( XB_DBG_ARG_VOID) ;  
XB_INL void	xb_Move32( XB_DBG_ARG_VOID) ;  
XB_INL void	xb_Logic16( XB_DBG_ARG_VOID) ;  
XB_INL void	xb_Logic32( XB_DBG_ARG_VOID) ;  
XB_INL X_INT16 xb_and(X_INT16 var1,X_INT16 var2 XB_DBG_ARG) ;
XB_INL X_INT16 xb_or(X_INT16 var1,X_INT16 var2 XB_DBG_ARG) ;
XB_INL X_INT16 xb_xor(X_INT16 var1,X_INT16 var2 XB_DBG_ARG) ;
XB_INL X_INT32 xb_L_and(X_INT32 var1,X_INT32 var2 XB_DBG_ARG) ;
XB_INL X_INT32 xb_L_or(X_INT32 var1,X_INT32 var2 XB_DBG_ARG) ;
XB_INL X_INT32 xb_L_xor(X_INT32 var1,X_INT32 var2 XB_DBG_ARG) ;

XB_INL void	xb_Test( XB_DBG_ARG_VOID) ;  



XB_INL void xb_set_carry(X_INT16 newC ) ;
XB_INL X_INT16 xb_get_carry(void) ;
XB_INL void xb_set_overflow(X_INT16 newOvF ) ;
XB_INL X_INT16 xb_get_Overflow(void) ;



#if defined(XB_INLINE) && !defined(_XBASICOPS_C)
#	include "xbasicops.c"
#endif

#endif
