/*=======================================================================================================*/
/*      Distributed Speech Recognition                                                                   */
/*      ETSI ES 202 050 Advanced Front-End Feature Extraction Algorithm & Compression Algorithm &        */
/*      ETSI ES 202 212 Extended Advanced Front-End Feature Extraction Algorithm & Compression Algorithm */  
/*      Bit exact C-language software implementation using ETSI basic operations library                 */
/*      3GPP TS 26.243 v 6.1.0 November 2004                                                                  */
/*      ANSI C code for the Fixed-Point Distributed Speech Recognition Extended Advanced Front-end       */
/*=======================================================================================================*/

#ifndef _NSEXPORTS_B_H
#define _NSEXPORTS_B_H

/* needed for 16kHz Processing DM */
#define SPEC_ORDER          65
#define twopi               (8.0*atan(1.0))

extern struct NoiseSupStructX_F *DoNoiseSupAlloc_B (void) ;
extern void             DoNoiseSupInit_B (FEParamsX_F *This) ;
#if defined(XAFE)
extern BOOLEAN          DoNoiseSup_B (X_INT16 *InData16, X_INT32 *OutData32, FEParamsX_F *This, X_INT16 *shftOut, Shortword *pswStft, Shortword *pswSignal, X_INT16 *piStftShift, X_INT16 *pidecalSig, X_INT16 *piProcessFlag);
extern BOOLEAN          DoPitchExtract_B(Shortword *pswStft, Shortword *pswSignal, X_INT16 iStftShift, X_INT16 decalSig, X_INT16 iProcessFlag, FEParamsX_F *This);
#else
extern BOOLEAN          DoNoiseSup_B (X_INT16 *InData16, X_INT32 *OutData32, FEParamsX_F *This, X_INT16 *shftOut);
#endif
extern void             DoNoiseSupDelete_B (struct NoiseSupStructX_F *NSX) ;


/* needed for 16kHz Processing DM */
extern void           InitMelFBwindows_F (MelFB_Window * FirstWin, float StFreq, float SmplFreq, int FFTLength, int NumChannels, BOOLEAN normalize);
extern void           ReleaseMelFBwindows_F (MelFB_Window *FirstWin);

#endif
